<template>
  <button
    type="button"
    @click="toggle"
  >
    music: {{ isEnabled ? 'on' : 'off' }}
  </button>
</template>

<script>
import { Howl, Howler } from 'howler'

export default {
  howl: null,
  props: {
    filePath: {
      type: String,
      required: true
    }
  },
  data() {
    const isEnabled = process.browser && localStorage.isMusicEnabled !== 'false'
    return {
      isEnabled
    }
  },
  mounted() {
    this.initialize()
  },
  beforeDestroy() {
    const { howl } = this.$options
    if (howl) {
      howl.stop()
    }
  },
  methods: {
    initialize() {
      if (!this.isEnabled) {
        return
      }

      const howl = new Howl({
        src: [`music/${this.filePath}.ogg`, `music/${this.filePath}.mp3`],
        loop: true
      })
      Object.assign(this.$options, { howl })
      howl.play()
    },
    toggle() {
      this.isEnabled = !this.isEnabled
      localStorage.isMusicEnabled = this.isEnabled

      const { howl } = this.$options
      if (howl) {
        if (this.isEnabled) {
          howl.play()
        } else {
          howl.stop()
        }
      } else {
        this.initialize()
      }
    }
  }
}
</script>

<style scoped>
button {
  position: absolute;
  right: 16px;
  top: 16px;
  z-index: 1000;
}
</style>
